qlserver 3.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: http://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="150316"
  12. #### Variables ####
  13. arch="x64"
  14. # Notification Email
  15. # (on|off)
  16. emailnotification="off"
  17. email="email@example.com"
  18. # Steam login
  19. steamuser="anonymous"
  20. steampass=""
  21. # Start Variables
  22. gameport="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${gameport}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. updateonstart="off"
  30. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${gameport} +set fs_homepath ${filesdir}/${gameport} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg} "
  34. }
  35. #### Advanced Variables ####
  36. # Github Branch Select
  37. # Allows for the use of different function files
  38. # from a different repo and/or branch.
  39. githubuser="dgibbs64"
  40. githubrepo="linuxgsm"
  41. githubbranch="master"
  42. # Steam
  43. appid="349090"
  44. # Server Details
  45. servicename="ql-server"
  46. gamename="Quake Live"
  47. engine="idtech3"
  48. # Directories
  49. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  50. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  51. lockselfname=".${servicename}.lock"
  52. filesdir="${rootdir}/serverfiles"
  53. systemdir="${filesdir}"
  54. executabledir="${filesdir}"
  55. executable=$([ "$arch" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  56. servercfg="${servicename}.cfg"
  57. servercfgdir="${filesdir}/baseq3"
  58. servercfgfullpath="${servercfgdir}/${servercfg}"
  59. servercfgdefault="${servercfgdir}/lgsm-default.cfg"
  60. backupdir="${rootdir}/backups"
  61. # Logging
  62. logdays="7"
  63. gamelogdir="${rootdir}/log/server"
  64. scriptlogdir="${rootdir}/log/script"
  65. consolelogdir="${rootdir}/log/console"
  66. gamelog="${gamelogdir}/${servicename}-game.log"
  67. scriptlog="${scriptlogdir}/${servicename}-script.log"
  68. consolelog="${consolelogdir}/${servicename}-console.log"
  69. emaillog="${scriptlogdir}/${servicename}-email.log"
  70. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  71. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  72. ##### Script #####
  73. # Do not edit
  74. # Fetches core_dl for file downloads
  75. fn_fetch_core_dl(){
  76. github_file_url_dir="lgsm/functions"
  77. github_file_url_name="${functionfile}"
  78. filedir="${functionsdir}"
  79. filename="${github_file_url_name}"
  80. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  81. # If the file is missing, then download
  82. if [ ! -f "${filedir}/${filename}" ]; then
  83. if [ ! -d "${filedir}" ]; then
  84. mkdir -p "${filedir}"
  85. fi
  86. echo -e " fetching ${filename}...\c"
  87. # Check curl exists and use available path
  88. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  89. for curlcmd in ${curlpaths}
  90. do
  91. if [ -x "${curlcmd}" ]; then
  92. break
  93. fi
  94. done
  95. # If curl exists download file
  96. if [ "$(basename ${curlcmd})" == "curl" ]; then
  97. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  98. if [ $? -ne 0 ]; then
  99. echo -e "\e[0;31mFAIL\e[0m\n"
  100. echo "${curlfetch}"
  101. echo -e "${githuburl}\n"
  102. exit 1
  103. else
  104. echo -e "\e[0;32mOK\e[0m"
  105. fi
  106. else
  107. echo -e "\e[0;31mFAIL\e[0m\n"
  108. echo "Curl is not installed!"
  109. echo -e ""
  110. exit 1
  111. fi
  112. chmod +x "${filedir}/${filename}"
  113. fi
  114. source "${filedir}/${filename}"
  115. }
  116. core_dl.sh(){
  117. # Functions are defined in core_functions.sh.
  118. functionfile="${FUNCNAME}"
  119. fn_fetch_core_dl
  120. }
  121. core_functions.sh(){
  122. # Functions are defined in core_functions.sh.
  123. functionfile="${FUNCNAME}"
  124. fn_fetch_core_dl
  125. }
  126. core_dl.sh
  127. core_functions.sh
  128. getopt=$1
  129. core_getopt.sh